;Make sure you have a backup of your project file in case something goes wrong.

;Make this nonzero to stop when a variable cannot be created
;Otherwise the script will open notepad with a list of variables that could
;not be created.
StopOnErrors=0

;This is how long the script waits for the create variable dialog to close in seconds
;If the script starts typing in the wrong spot and causing all sorts of mischief, then
;increase this value.
DialogWait=0.5




SetWorkingDir %A_ScriptDir%
;Open file dialog for user to select csv file
FileSelectFile, CSVPath, 3,,, Comma-separated Values (*.csv)

if !CSVPath
  Exit

#NoEnv
SendMode Input

ErrorList := ""

WinActivate, PAC Control
WinWaitActive, PAC Control,,2
IfWinNotActive, PAC Control
{
  MsgBox Could not activate PAC Control.
  Exit
}


;Get to configure Variables
WinMenuSelectItem, PAC Control,,Configure,Variables...

WinWaitActive ,Configure Variables ahk_class #32770,,2
if ErrorLevel
{
  MsgBox Could not open Configure Variables.
  Exit
}

Loop, Read, %CSVPath%
{
  if A_Index > 1 ;Skip the heading
  {
    Loop, Parse, A_LoopReadLine, CSV
    {
      if A_Index = 1
        Name=%A_Loopfield%
      else if A_Index = 2
        Description=%A_Loopfield%
      else if A_Index = 3
        DataType=%A_Loopfield%
      else if A_Index = 4
        Initialization=%A_Loopfield%
      else if A_Index = 5
        InitValue=%A_Loopfield%
      else if A_Index = 6
        Length=%A_Loopfield%
      else if A_Index = 7
        Width=%A_Loopfield%
      else if A_Index = 8
        PointerType=%A_Loopfield%
    }

    WinWaitActive ,Configure Variables ahk_class #32770,,2
    if ErrorLevel
    {
      MsgBox Expected Configure Variables to be the active window.  Consider increasing the value in DialogWait.
      Exit
    }

    ;!t moves to type dropdown then C get to known position in list before going where we want
    SendInput !tc
    
    if DataType In Integer 32,Integer 64,Float
    {
      SendInput nn ;nn gets to Numeric Variables
      SendInput !a

      ;Wait for dialog to open
      WinWaitActive ,Add Variable ahk_class #32770,,%DialogWait%
      
      SendInput !n%Name%{TAB}%Description%{TAB}

      if DataType = Integer 64
        SendInput i
      else if DataType = Float
        SendInput f

      SendInput {TAB}
      
      if Initialization = download
        SendInput {Down}
      else if Initialization = persistent
        SendInput {Down 2}
        
      SendInput {TAB}%InitValue%{Enter}
    }
    else if DataType In Up Timer,Down Timer
    {
      SendInput nn ;nn gets to Numeric Variables
      SendInput !a

      ;Wait for dialog to open
      WinWaitActive ,Add Variable ahk_class #32770,,%DialogWait%
      
      SendInput !n%Name%{TAB}%Description%{TAB}

      if DataType = Up Timer
        SendInput u
      else if DataType = Down Timer
        SendInput d
      SendInput {ENTER}
    }  
    else if DataType In Integer 32 Table,Integer 64 Table,Float Table
    {
      SendInput n ;n gets to Numeric Tables
      SendInput !a

      ;Wait for dialog to open
      WinWaitActive ,Add Variable ahk_class #32770,,%DialogWait%
      
      SendInput !n%Name%{TAB}%Description%{TAB}
      
      if DataType = Integer 64 Table
        SendInput i
      else if DataType = Float Table
        SendInput f

      SendInput {TAB}%Length%{TAB}
      
      if Initialization = download
        SendInput {Down}
      else if Initialization = persistent
        SendInput {Down 2}
      
      SendInput {TAB}%InitValue%{Enter} 
    }
    else if DataType = String
    {
      SendInput ss
      SendInput !a

      ;Wait for dialog to open
      WinWaitActive ,Add Variable ahk_class #32770,,%DialogWait%
      
      SendInput !n%Name%{TAB}%Description%{TAB}

      SendInput {TAB}%Width%{TAB}
      
      if Initialization = download
        SendInput {Down}
      else if Initialization = persistent
        SendInput {Down 2}
      
      SendInput {TAB}%InitValue%{Enter} 
    }
    else if DataType = String Table
    {
      SendInput s
      SendInput !a

      ;Wait for dialog to open
      WinWaitActive ,Add Variable ahk_class #32770,,%DialogWait%
      
      SendInput !n%Name%{TAB}%Description%{TAB}

      SendInput {TAB}%Length%{TAB}%Width%{TAB}
      
      if Initialization = download
        SendInput {Down}
      else if Initialization = persistent
        SendInput {Down 2}
      
      SendInput {TAB}%InitValue%{Enter} 
    }
    else if DataType = Pointer
    {
      SendInput pp
      SendInput !a

      ;Wait for dialog to open
      WinWaitActive ,Add Variable ahk_class #32770,,%DialogWait%
      
      SendInput !n%Name%{TAB}%Description%{TAB}

      SendInput {TAB}%PointerType%{TAB}
      
      if Initialization = download
        SendInput {Down}  
      
      SendInput {TAB}%InitValue%{Enter}
    }
    else if DataType = Pointer Table
    {
      SendInput p
      SendInput !a

      ;Wait for dialog to open
      WinWaitActive ,Add Variable ahk_class #32770,,%DialogWait%
      
      SendInput !n%Name%{TAB}%Description%{TAB}

      SendInput {TAB}%Length%{TAB}
      
      if Initialization = download
        SendInput {Down}  
      
      SendInput {Enter}
    }
    else if DataType = Communication Handle
    {
      SendInput c
      SendInput !a

      ;Wait for dialog to open
      WinWaitActive ,Add Variable ahk_class #32770,,%DialogWait%
      
      SendInput !n%Name%{TAB}%Description%{TAB 2}


      if Initialization = download
        SendInput {Down}
      else if Initialization = persistent
        SendInput {Down 2}
      
      SendInput {TAB}%InitValue%{Enter}
    }
    
    ;Make sure Add Variable Window closed
    WinWaitClose ,Add Variable ahk_class #32770,,%DialogWait%
    if ErrorLevel
    {
      if StopOnErrors
      {
        MsgBox Error adding variable.
        Exit
      }
      else
      {
        ErrorList := ErrorList . Name . "`n"
        SendInput {ESC}
        IfWinActive  ,Add Variable ahk_class #32770
        {
          WinWaitClose ,Add Variable ahk_class #32770,,%DialogWait%
          if ErrorLevel
          {
            SendInput {ESC}
          }
        }
      }
    }
  }
}
SendInput {ESC}

if ErrorList
{ 
  run, Notepad.exe,,,notePadPID 
  WinWait, ahk_pid %notepadPID%
  WinActivate, ahk_pid %notepadPID%
  WinWaitActive, ahk_pid %notepadPID%,,2
  IfWinActive, ahk_pid %notepadPID%
    SendInput % "The following variables were not able to be created:`n" . ErrorList
}

